package de.ozgcloud.user.common.callcontext;

import java.nio.charset.StandardCharsets;
import java.util.Collection;
import java.util.Optional;
import java.util.stream.Stream;
import java.util.stream.StreamSupport;

import io.grpc.Metadata;
import io.grpc.Metadata.Key;

// TODO move to a grpcUtil class in common
class GrpcUtil {

	public static Optional<String> getFromHeaders(String key, Metadata headers) {
		return Optional.ofNullable(headers.get(createKeyOf(key)))
				.map(GrpcUtil::toUtf8String);
	}

	public static Collection<String> getCollection(String key, Metadata headers) {
		return Optional.ofNullable(headers.getAll(createKeyOf(key)))
				.map(GrpcUtil::split)
				.orElseGet(Stream::empty)
				.map(GrpcUtil::toUtf8String)
				.toList();
	}

	public static Key<byte[]> createKeyOf(String key) {
		return Key.of(key, Metadata.BINARY_BYTE_MARSHALLER);
	}

	private static Stream<byte[]> split(Iterable<byte[]> vals) {
		return StreamSupport.stream(vals.spliterator(), false);
	}

	private static String toUtf8String(byte[] bytes) {
		return new String(bytes, StandardCharsets.UTF_8);
	}
}